/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Download Sort.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


// old functions
var __foundHeaderInfo = window.foundHeaderInfo;
var __contentAreaClick = window.contentAreaClick;

window.addEventListener("load", downsortinit, true);
//window.addEventListener("unload", downsortclose, false);
var ds_datasource;
//var ds_sink;
var ds_remote;
var ds_loaded;
var wrap_ds;

var ds_RDFC = '@mozilla.org/rdf/container;1';
ds_RDFC = Components.classes[ds_RDFC].createInstance();
ds_RDFC = ds_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var ds_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
ds_RDFCUtils = Components.classes[ds_RDFCUtils].getService();
ds_RDFCUtils = ds_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var ds_RDF = '@mozilla.org/rdf/rdf-service;1';
ds_RDF = Components.classes[ds_RDF].getService();
ds_RDF = ds_RDF.QueryInterface(Components.interfaces.nsIRDFService);
	
//var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);


function downsortinit() {
	
	if (!ds_loaded) {
		ds_loaded = true;
	  	//window.removeEventListener("load", downsortinit, true);
	  	// Set replacement functions
	  	window.foundHeaderInfo = ds_foundHeaderInfo;
	  	window.contentAreaClick = ds_contentAreaClick;
	  	
		//toJavaScriptConsole();

		var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		// From TBE
		const DIR = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
		var dir = DIR.get('ProfD', Components.interfaces.nsILocalFile);

		var tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		tempLocalFile.initWithPath(dir.path);

		var uri;
		try {
			uri = gIOService.newFileURI(tempLocalFile).spec;
		}
		catch(e) {}

		if (!uri.match(/\/$/)) uri += '/';
		// /from TBE
		

		// Old - Firefox 0.9 removed the profile interface??? - check and see what optimoz uses
		// Get to the profile directory and the datasource downsort.rdf
		//var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		//var profile = Components.classes["@mozilla.org/profile/manager;1"].getService(Components.interfaces.nsIProfileInternal);
		//var gProfileDirURL = gIOService.newFileURI(profile.getProfileDir(profile.currentProfile));
		
		// Need to remove one of these two, no sense in using both.  One is the plain datasource, one is a wrapper for the datasource using rdfds.js
		// Remove the wrapper and do the one save operation manually, (for selectLast)
		//ds_datasource = ds_RDF.GetDataSourceBlocking("file://" + gProfileDirURL.path + "downsort.rdf"); // Old
		ds_datasource = ds_RDF.GetDataSourceBlocking(uri + "downsort.rdf"); // New
		//wrap_ds = new RDFDataSource("file://" + gProfileDirURL.path + "downsort.rdf");  // Old Wrapper for RDF operations
		wrap_ds = new RDFDataSource(uri + "downsort.rdf");  // Wrapper for RDF operations
		
		// Make sure the rootnodes are there and set up, on error, they are created
		var extRootNode = ds_RDF.GetResource("NC:ExtensionRoot");
		var keyRootNode = ds_RDF.GetResource("NC:KeywordRoot");
		try {  
	      ds_RDFC.Init(ds_datasource,extRootNode);
	    } catch (e) {
	      ds_RDFCUtils.MakeSeq(ds_datasource,extRootNode);
	      ds_RDFC.Init(ds_datasource,extRootNode);
	    }
	    try {  
	      ds_RDFC.Init(ds_datasource,keyRootNode);
	    } catch (e) {
	      ds_RDFCUtils.MakeSeq(ds_datasource,keyRootNode);
	      ds_RDFC.Init(ds_datasource,keyRootNode);
	    }

		ds_remote = ds_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);

	/*	if (ds_remote.loaded) { 
			acs.logStringMessage("the datasource was already loaded!");
		} 
		else { 
			acs.logStringMessage("the datasource wasn't loaded, but it's loading now!");
		}
		ds_remote.Flush();
		// RDF/XML Datasources are all nsIRDFXMLSinks  
		ds_sink = ds_datasource.QueryInterface(Components.interfaces.nsIRDFXMLSink);  
		// Attach the observer to the datasource-as-sink  
		ds_sink.addXMLSinkObserver(ds_rdfObserver);  
	*/	
	}
	
}

// This is the object that will observe the RDF/XML load's progress 
/*var ds_rdfObserver = { 
	onBeginLoad: function(aSink) {}, 
	onInterrupt: function(aSink) {}, 
	onResume: function(aSink) {}, 
	onEndLoad: function(aSink) { 
		acs.logStringMessage("done!");
		
	}, 
	onError: function(aSink, aStatus, aErrorMsg) { 
		acs.logStringMessage("error! " + aErrorMsg); 
	} 

};
*/

function downsortclose() {
	//window.removeEventListener("unload", downsortclose, false);
	//sink.removeXMLSinkObserver(ds_rdfObserver);	
}

// Replacement function
function ds_foundHeaderInfo(aSniffer, aData, aSkipPrompt) {
	
	var contentType = aSniffer.contentType;
	var contentEncodingType = aSniffer.contentEncodingType;
	
	var shouldDecode = false;
	// Are we allowed to decode?
	try {
	const helperAppService =
	  Components.classes["@mozilla.org/uriloader/external-helper-app-service;1"].
	    getService(Components.interfaces.nsIExternalHelperAppService);
		var url = aSniffer.uri.QueryInterface(Components.interfaces.nsIURL);
		var urlExt = url.fileExtension;
		if (helperAppService.applyDecodingForType(contentType) &&
		    (!urlExt || helperAppService.applyDecodingForExtension(urlExt))) {
		  shouldDecode = true;
		}
	}
	catch (e) {
	}

	var isDocument = aData.document != null && isDocumentType(contentType);
	if (!isDocument && !shouldDecode && contentEncodingType) {
		// The data is encoded, we are not going to decode it, and this is not a
		// document save so we won't be doing a "save as, complete" (which would
		// break if we reset the type here).  So just set our content type to
		// correspond to the outermost encoding so we get extensions and the like
		// right.
		contentType = contentEncodingType;
	}
	
	// Determine what the 'default' string to display in the File Picker dialog 
	// should be. 
	var defaultFileName = getDefaultFileName(aData.fileName, 
	                                       aSniffer.suggestedFileName, 
	                                       aSniffer.uri,
	                                       aData.document);

	var defaultExtension = getDefaultExtension(defaultFileName, aSniffer.uri, contentType);
	defaultExtension = defaultExtension.toLowerCase();
	var defaultString = getNormalizedLeafName(defaultFileName, defaultExtension);
	
	const prefSvcContractID = "@mozilla.org/preferences-service;1";
	const prefSvcIID = Components.interfaces.nsIPrefService;                              
	//var prefs = Components.classes[prefSvcContractID].getService(prefSvcIID).getBranch("browser.download.");
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	const nsILocalFile = Components.interfaces.nsILocalFile;
	const lfContractID = "@mozilla.org/file/local;1";
	
	var dir = null;
	var autoSaving;
	var autoLocation;
	var autoAction;
	var autoSubf;
	var downsorted = false;  // used in the askipprompt if statement below to separate downsorted thing from non-downsorted
	//var autoOthSubf = "";
	
	var MYdefaultExtension = defaultExtension;
	//acs.logStringMessage(defaultExtension);
	if (MYdefaultExtension == "") 
		MYdefaultExtension = aData.url.split(".").pop();   // If the download is served as text/plain, firbird decides the default ex. is "".  grrrr.  I want to be able to capture rar files and the like.
	//acs.logStringMessage(MYdefaultExtension);
	//acs.logStringMessage(aData.url);
	
	// Get a reference to all the keywords and go through and check each one against the url
	var keyroot = ds_RDF.GetResource("NC:KeywordRoot");
    var ds_RDFCont = Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
    ds_RDFCont.Init(ds_datasource, keyroot);
    var keygroup = ds_RDFCont.GetElements();
    var match = "0";
    var matchResult = -1;
    var extRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#ext");
    while (keygroup.hasMoreElements()) {
    	var aKeywordRes = keygroup.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    	aKeyword = ds_datasource.GetTarget(aKeywordRes, extRDF, true);
		aKeyword = aKeyword.QueryInterface(Components.interfaces.nsIRDFLiteral).Value.toLowerCase();
		//acs.logStringMessage(aKeyword);
		matchResult = aData.url.toLowerCase().indexOf(aKeyword);  // Matching here, -1 means no match
		//acs.logStringMessage(matchResult);
		if (matchResult != -1) {
			//acs.logStringMessage("match!");
			break;
		}
		else {
			//acs.logStringMessage("nomatch");
		}
    }
    
    var aSource;
    try {
    	if (matchResult != -1) {// If we had a keyword match, use that info
			aSource = ds_RDF.GetResource("NC:KeywordRoot:" + aKeyword);
			
		}
		else  				   // else try the extension
			aSource = ds_RDF.GetResource("NC:ExtensionRoot:" + MYdefaultExtension);  // if this fails, it will skip the rest of the try block and do the error block which contains the standard download procedure

		
		// then read it's values
		try { // These resources aren't in the old version downsort.rdf - catch the error if we fail to find them
			var savRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#saving");
			autoSaving = ds_datasource.GetTarget(aSource, savRDF, true);
			autoSaving = autoSaving.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			
			var subfRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#subfolder");
			autoSubf = ds_datasource.GetTarget(aSource, subfRDF, true);
			autoSubf = autoSubf.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			
		} catch(e) {  // For backwards compatibility to downsort.rdf from version 1.0
			autoSaving = "selectAuto";
			autoSubf = "selectNone";
		}
		
		var locRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#location");
		autoLocation = ds_datasource.GetTarget(aSource, locRDF, true);
		//acs.logStringMessage("foundext");
		autoLocation = autoLocation.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		
		var actionRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#action");
		autoAction = ds_datasource.GetTarget(aSource, actionRDF, true);
		autoAction = autoAction.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		
		/* if (autoSubf == "selectOth") {  // Only need this if the subfolder is set to other OTHER SUBFOLDER DEPRECIATED - useless
			var othSubfRDF = ds_RDF.GetResource("http://home.netscape.com/NC-rdf#othersub");
			autoOthSubf = ds_datasource.GetTarget(aSource, othSubfRDF, true);
			autoOthSubf = autoOthSubf.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
		}*/
		
		//acs.logStringMessage(autoSaving);
		//acs.logStringMessage(autoLocation);
		//acs.logStringMessage(autoAction);
		//acs.logStringMessage(autoSubf);
		//acs.logStringMessage(autoOthSubf);
		
		if (autoSubf != "selectNone") {  // Then we need to append subfolder to the location
			var subaddon;
			if (autoSubf == "selectDate") {
				try {
					var USdate = prefs.getBoolPref("downsort.dateform.us");
				} catch (e) {}
				var date = new Date();
				var d  = date.getDate();
				var day = (d < 10) ? '0' + d : d;
				var m = date.getMonth() + 1;
				var month = (m < 10) ? '0' + m : m;
				var yy = date.getYear();
				var year = (yy < 1000) ? yy + 1900 : yy;
				if (USdate) 
					subaddon = month + "." + day + "." + year;
				else
					subaddon = year + "." + month + "." + day;
					
			}
			else {  // == "selectSite"
				subaddon = aSniffer.uri.host;
				//subaddon = subaddon + aSniffer.uri.directory.replace(/\//g,"\\");  // just for you ghk - this part still windows only
			}
			if (autoLocation.charAt(0) == "/")  // Linux filesystem
				autoLocation = autoLocation + "/" + subaddon;
			else								// Windows
				autoLocation = autoLocation + "\\" + subaddon;

		}
		
		dir = Components.classes[lfContractID].createInstance(nsILocalFile);
		dir.initWithPath(autoLocation);
		try {
			dir.create(1, 0777); // might be new subfolder
		} catch (e) {}
		
		
		// Now test which kind of save to do - auto or prompt in folder
		if (autoSaving == "selectSame" | autoSaving == "selectLast") { // Both prompt types do the same thing initially
			aSkipPrompt = false;
			downsorted = true;
		}
		else {  // auto saving without prompt
			downsorted = true;
			var testdir = Components.classes[lfContractID].createInstance(nsILocalFile);
			testdir.initWithPath(autoLocation);
			testdir.append(defaultString);
			aSkipPrompt = true;
			
			if (testdir.exists()) {
				//acs.logStringMessage("alreadyexists");
	  	  		if (autoAction == "selectCanc") {
	  	  			//var dlpref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	  	  			
	  	  			try {
	  	  				var soundpref = prefs.getBoolPref("downsort.cancel.sound");
	  	  				var showpref = prefs.getBoolPref("downsort.cancel.show");
	  	  			}
	  	  			catch (e) {}
	  	  			
	  	  			if (soundpref) {
		  	  			// Play a sound
		  	  			var kSOUNDContractID = "@mozilla.org/sound;1";
		  				var kSOUNDIID = Components.interfaces.nsISound;
		  				var sound = Components.classes[kSOUNDContractID].createInstance(kSOUNDIID);
		  				sound.beep();
		  			}
		  			
		  			if (showpref) {
		  				dir.reveal();
		  			}
	  	  			//acs.logStringMessage("canceling");
	  	  			return;
	  	  		}
	  	  		if (autoAction == "selectPrompt") {
	    			aSkipPrompt = false;
	    		}
	    		else {
	    			dir.append(defaultString); 
	    		}
	  	  		if (autoAction == "selectIncr") {
	    			dir.createUnique(0, 0777);
	    		}
	    		
	    	}
	    	else {
	    		dir.append(defaultString);
	    	}
		}
	}
	catch (e) {
		try {
	  		dir = prefs.getComplexValue("browser.download.defaultFolder", nsILocalFile);
	  	}
	  	catch (e) {}
	}
	
	var filterIndex = 0;
	var file;
	//acs.logStringMessage(dir.path);
	if (!aSkipPrompt || !dir) {
		
		if (!downsorted) {
			// If we're asking the user where to save the file, root the Save As...
	    	// dialog on they place they last picked. 
	    	try {
	    	  dir = prefs.getComplexValue("browser.download.lastDir", nsILocalFile);
	    	}
	    	catch (e) {
		      	// No default download location. Default to desktop. 
		      	var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		
		      	function getDesktopKey()
		      	{      
		        	return "DeskV";
		        	return "Home";
		      	}
		      
		      	dir = fileLocator.get(getDesktopKey(), Components.interfaces.nsILocalFile);
	    	}
	    }
		
		var fp = makeFilePicker();
		var titleKey = aData.filePickerTitle || "SaveLinkTitle";
		var bundle = getStringBundle();
		fp.init(window, bundle.GetStringFromName(titleKey), 
		        Components.interfaces.nsIFilePicker.modeSave);
		
		appendFiltersForContentType(fp, contentType,
		                            isDocument ? MODE_COMPLETE : MODE_FILEONLY);
		
		if (dir)
		  fp.displayDirectory = dir;
		
		if (isDocument) {
		  try {
		    fp.filterIndex = prefs.getIntPref("browser.download.save_converter_index");
		  }
		  catch (e) {
		  }
		}
		
		fp.defaultExtension = defaultExtension;
		fp.defaultString = defaultString;
		
		if (fp.show() == Components.interfaces.nsIFilePicker.returnCancel || !fp.file)
		  return;
		
		// If prompt in last is selected we need to save the new path
		if (downsorted) {
			if (autoSaving == "selectLast") {
				//acs.logStringMessage("new loc: " + fp.file.parent.path);
				var node = wrap_ds.getNode("NC:ExtensionRoot");
				var childName = "NC:ExtensionRoot:" + MYdefaultExtension;
				var child = wrap_ds.getNode(childName);
				child = node.addChild(child);
				child.addTargetOnce("http://home.netscape.com/NC-rdf#location", fp.file.parent.path);
				wrap_ds.save();
			}
		}
		
		var useDownloadDir = false;
		try {
		  useDownloadDir = prefs.getBoolPref("browser.download.useDownloadDir");
		}
		catch(ex) {
		}
		
		//if (!useDownloadDir) {
		var directory = fp.file.parent.QueryInterface(nsILocalFile);
		prefs.setComplexValue("browser.download.lastDir", nsILocalFile, directory);
		//}
		fp.file.leafName = validateFileName(fp.file.leafName);
		filterIndex = fp.filterIndex;
		file = fp.file;
    }
	else {
		//acs.logStringMessage(dir.path);
		if (!downsorted)
			dir.append(defaultString);
		file = dir;
		if (!downsorted) {
			while (file.exists()) {
		      var parts = /.+-(\d+)(\..*)?$/.exec(file.leafName);
		      if (parts) {
		        file.leafName = file.leafName.replace(/((\d+)\.)/, 
		                                              function (str, p1, part, s) { 
		                                                return (parseInt(part) + 1) + "."; 
		                                              });
		      }
		      else {
		        file.leafName = file.leafName.replace(/\./, "-1$&");
		      }
		    }
		}
	}
	if (isDocument) 
		prefs.setIntPref("browser.download.save_converter_index", filterIndex);

	// If we're saving a document, and are saving either in complete mode or 
	// as converted text, pass the document to the web browser persist component.
	// If we're just saving the HTML (second option in the list), send only the URI.
	var source = (isDocument && filterIndex != 1) ? aData.document : aSniffer.uri;
	var persistArgs = {
		source      : source,
		contentType : (isDocument && filterIndex == 2) ? "text/plain" : contentType,
		//target      : file,
		target      : makeFileURL(file),
		postData    : aData.document ? getPostData() : null,
		bypassCache : aData.bypassCache
	};
	var persist = makeWebBrowserPersist();

	// Calculate persist flags.
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
	const flags = nsIWBP.PERSIST_FLAGS_NO_CONVERSION | nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
	if (aData.bypassCache)
    	persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
	else 
    	persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

	if (shouldDecode)
    	persist.persistFlags &= ~nsIWBP.PERSIST_FLAGS_NO_CONVERSION;
    
	// Create download and initiate it (below)
	var dl = Components.classes["@mozilla.org/download;1"].createInstance(Components.interfaces.nsIDownload);
	if (isDocument && filterIndex != 1) {
		// Saving a Document, not a URI:
		var filesFolder = null;
		if (persistArgs.contentType != "text/plain") {
			// Create the local directory into which to save associated files.
			filesFolder = file.clone();
			
			var nameWithoutExtension = filesFolder.leafName;
			nameWithoutExtension = nameWithoutExtension.substring(0, nameWithoutExtension.lastIndexOf("."));
			var filesFolderLeafName = getStringBundle().formatStringFromName("filesFolder",
			                                                               [nameWithoutExtension],
			                                                               1);

      		filesFolder.leafName = filesFolderLeafName;
    	}
      
		var encodingFlags = 0;
		if (persistArgs.contentType == "text/plain") {
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_FORMATTED;
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_ABSOLUTE_LINKS;
		  encodingFlags |= nsIWBP.ENCODE_FLAGS_NOFRAMES_CONTENT;        
		}
    
    
		const kWrapColumn = 80;
		dl.init(aSniffer.uri, persistArgs.target, null, null, null, persist);
		persist.saveDocument(persistArgs.source, persistArgs.target, filesFolder, 
		                     persistArgs.contentType, encodingFlags, kWrapColumn);
  	} else {
    dl.init(source, persistArgs.target, null, null, null, persist);
    persist.saveURI(source, null, getReferrer(document), persistArgs.postData, null, persistArgs.target);
  }
}


// This whole replacement function (original from browser.js) is so that single clicks on files set to download will also be sorted
function ds_contentAreaClick(event) 
 {
 	
   var target = event.target;
   var linkNode;

   var local_name = target.localName;

   if (local_name) {
     local_name = local_name.toLowerCase();
   }

   switch (local_name) {
     case "a":
     case "area":
     case "link":
       if (target.hasAttribute("href")) 
         linkNode = target;
       break;
     default:
       linkNode = findParentNode(event.originalTarget, "a");
       // <a> cannot be nested.  So if we find an anchor without an
       // href, there is no useful <a> around the target
       if (linkNode && !linkNode.hasAttribute("href"))
         linkNode = null;
       break;
   }
   if (linkNode) {
     var keymodified = handleLinkClick(event, linkNode.href, linkNode);
     if(!keymodified && event.button == 0){
     	var ds_file = linkNode.href.split("/").pop().split(".");
     	if (ds_file.length > 1) {
     		var ds_fileext = ds_file[ds_file.length - 1].toLowerCase();
     		if (ds_fileext != "html" && ds_fileext != "htm" && ds_fileext != "php" && ds_fileext != "shtml"  && ds_fileext != "phtml" && ds_fileext != "xpi") {
     			//acs.logStringMessage(ds_fileext);
     			var MIMEService = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
     			var MIMEInfo = Components.classes["@mozilla.org/mime-info;1"].getService(Components.interfaces.nsIMIMEInfo);
     			try {
     				MIMEInfo = MIMEService.getFromTypeAndExtension(null, ds_fileext);
     				if (MIMEInfo.preferredAction == 0) {
     					//acs.logStringMessage("Saving");
     					saveURL(linkNode.href, "");
     					//event.preventBubble();
     					return false;
     				}
     			} catch(e) {}//acs.logStringMessage("notfound");}
     		}
     	}
     }
     return true;
   } else {
     // Try simple XLink
     var href;
     linkNode = target;
     while (linkNode) {
       if (linkNode.nodeType == Node.ELEMENT_NODE) {
         href = linkNode.getAttributeNS("http://www.w3.org/1999/xlink", "href");
         break;
       }
       linkNode = linkNode.parentNode;
     }
     if (href && href != "") {
       href = makeURLAbsolute(target.baseURI,href);
       handleLinkClick(event, href, null);
       return true;
     }
   }
   if (event.button == 1 &&
       !findParentNode(event.originalTarget, "scrollbar") &&
       gPrefService.getBoolPref("middlemouse.contentLoadURL")) {
     if (middleMousePaste(event)) {
       event.preventBubble();
     }
   }
   return true;
 }